package io.grpc.examples.streaming;

import static io.grpc.examples.streaming.StreamingGrpc.getServiceDescriptor;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;


@javax.annotation.Generated(
value = "by VertxGrpc generator",
comments = "Source: streaming.proto")
public final class VertxStreamingGrpc {
    private VertxStreamingGrpc() {}

    public static StreamingVertxStub newVertxStub(io.grpc.Channel channel) {
        return new StreamingVertxStub(channel);
    }

    /**
     * <pre>
     *  Interface exported by the server.
     * </pre>
     */
    public static final class StreamingVertxStub extends io.grpc.stub.AbstractStub<StreamingVertxStub> {
        private final io.vertx.core.impl.ContextInternal ctx;
        private StreamingGrpc.StreamingStub delegateStub;

        private StreamingVertxStub(io.grpc.Channel channel) {
            super(channel);
            delegateStub = StreamingGrpc.newStub(channel);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        private StreamingVertxStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            super(channel, callOptions);
            delegateStub = StreamingGrpc.newStub(channel).build(channel, callOptions);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        @Override
        protected StreamingVertxStub build(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            return new StreamingVertxStub(channel, callOptions);
        }

        
        public io.vertx.core.streams.ReadStream<io.grpc.examples.streaming.Item> source(io.grpc.examples.streaming.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToMany(ctx, request, delegateStub::source);
        }

        
        public io.vertx.core.Future<io.grpc.examples.streaming.Empty> sink(io.vertx.core.Handler<io.vertx.core.streams.WriteStream<io.grpc.examples.streaming.Item>> hdlr) {
            return io.vertx.grpc.stub.ClientCalls.manyToOne(ctx, hdlr, delegateStub::sink);
        }

        
        public io.vertx.core.streams.ReadStream<io.grpc.examples.streaming.Item> pipe(io.vertx.core.Handler<io.vertx.core.streams.WriteStream<io.grpc.examples.streaming.Item>> hdlr) {
            return io.vertx.grpc.stub.ClientCalls.manyToMany(ctx, hdlr, delegateStub::pipe);
        }
    }

    /**
     * <pre>
     *  Interface exported by the server.
     * </pre>
     */
    public static abstract class StreamingVertxImplBase implements io.grpc.BindableService {
        private String compression;

        /**
         * Set whether the server will try to use a compressed response.
         *
         * @param compression the compression, e.g {@code gzip}
         */
        public StreamingVertxImplBase withCompression(String compression) {
            this.compression = compression;
            return this;
        }

        
        public void source(io.grpc.examples.streaming.Empty request, io.vertx.core.streams.WriteStream<io.grpc.examples.streaming.Item> response) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        
        public io.vertx.core.Future<io.grpc.examples.streaming.Empty> sink(io.vertx.core.streams.ReadStream<io.grpc.examples.streaming.Item> request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        
        public void pipe(io.vertx.core.streams.ReadStream<io.grpc.examples.streaming.Item> request, io.vertx.core.streams.WriteStream<io.grpc.examples.streaming.Item> response) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
            return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
                    .addMethod(
                            io.grpc.examples.streaming.StreamingGrpc.getSourceMethod(),
                            asyncServerStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.examples.streaming.Empty,
                                            io.grpc.examples.streaming.Item>(
                                            this, METHODID_SOURCE, compression)))
                    .addMethod(
                            io.grpc.examples.streaming.StreamingGrpc.getSinkMethod(),
                            asyncClientStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.examples.streaming.Item,
                                            io.grpc.examples.streaming.Empty>(
                                            this, METHODID_SINK, compression)))
                    .addMethod(
                            io.grpc.examples.streaming.StreamingGrpc.getPipeMethod(),
                            asyncBidiStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.examples.streaming.Item,
                                            io.grpc.examples.streaming.Item>(
                                            this, METHODID_PIPE, compression)))
                    .build();
        }
    }

    private static final int METHODID_SOURCE = 0;
    private static final int METHODID_SINK = 1;
    private static final int METHODID_PIPE = 2;

    private static final class MethodHandlers<Req, Resp> implements
            io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {

        private final StreamingVertxImplBase serviceImpl;
        private final int methodId;
        private final String compression;

        MethodHandlers(StreamingVertxImplBase serviceImpl, int methodId, String compression) {
            this.serviceImpl = serviceImpl;
            this.methodId = methodId;
            this.compression = compression;
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_SOURCE:
                    io.vertx.grpc.stub.ServerCalls.oneToMany(
                            (io.grpc.examples.streaming.Empty) request,
                            (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item>) responseObserver,
                            compression,
                            serviceImpl::source);
                    break;
                default:
                    throw new java.lang.AssertionError();
            }
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public io.grpc.stub.StreamObserver<Req> invoke(io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_SINK:
                    return (io.grpc.stub.StreamObserver<Req>) io.vertx.grpc.stub.ServerCalls.manyToOne(
                            (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Empty>) responseObserver,
                            compression,
                            serviceImpl::sink);
                case METHODID_PIPE:
                    return (io.grpc.stub.StreamObserver<Req>) io.vertx.grpc.stub.ServerCalls.manyToMany(
                            (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item>) responseObserver,
                            compression,
                            serviceImpl::pipe);
                default:
                    throw new java.lang.AssertionError();
            }
        }
    }

}
