package io.grpc.testing.integration;

import static io.grpc.testing.integration.ReconnectServiceGrpc.getServiceDescriptor;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;


@javax.annotation.Generated(
value = "by VertxGrpc generator",
comments = "Source: test.proto")
public final class VertxReconnectServiceGrpc {
    private VertxReconnectServiceGrpc() {}

    public static ReconnectServiceVertxStub newVertxStub(io.grpc.Channel channel) {
        return new ReconnectServiceVertxStub(channel);
    }

    /**
     * <pre>
     *  A service used to control reconnect server.
     * </pre>
     */
    public static final class ReconnectServiceVertxStub extends io.grpc.stub.AbstractStub<ReconnectServiceVertxStub> {
        private final io.vertx.core.impl.ContextInternal ctx;
        private ReconnectServiceGrpc.ReconnectServiceStub delegateStub;

        private ReconnectServiceVertxStub(io.grpc.Channel channel) {
            super(channel);
            delegateStub = ReconnectServiceGrpc.newStub(channel);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        private ReconnectServiceVertxStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            super(channel, callOptions);
            delegateStub = ReconnectServiceGrpc.newStub(channel).build(channel, callOptions);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        @Override
        protected ReconnectServiceVertxStub build(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            return new ReconnectServiceVertxStub(channel, callOptions);
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> start(com.google.protobuf.EmptyProtos.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::start);
        }

        /**
         * <pre>
         *  One request followed by one response.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.ReconnectInfo> stop(com.google.protobuf.EmptyProtos.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::stop);
        }

    }

    /**
     * <pre>
     *  A service used to control reconnect server.
     * </pre>
     */
    public static abstract class ReconnectServiceVertxImplBase implements io.grpc.BindableService {
        private String compression;

        /**
         * Set whether the server will try to use a compressed response.
         *
         * @param compression the compression, e.g {@code gzip}
         */
        public ReconnectServiceVertxImplBase withCompression(String compression) {
            this.compression = compression;
            return this;
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> start(com.google.protobuf.EmptyProtos.Empty request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  One request followed by one response.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.ReconnectInfo> stop(com.google.protobuf.EmptyProtos.Empty request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
            return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
                    .addMethod(
                            io.grpc.testing.integration.ReconnectServiceGrpc.getStartMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            com.google.protobuf.EmptyProtos.Empty,
                                            com.google.protobuf.EmptyProtos.Empty>(
                                            this, METHODID_START, compression)))
                    .addMethod(
                            io.grpc.testing.integration.ReconnectServiceGrpc.getStopMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            com.google.protobuf.EmptyProtos.Empty,
                                            io.grpc.testing.integration.Messages.ReconnectInfo>(
                                            this, METHODID_STOP, compression)))
                    .build();
        }
    }

    private static final int METHODID_START = 0;
    private static final int METHODID_STOP = 1;

    private static final class MethodHandlers<Req, Resp> implements
            io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {

        private final ReconnectServiceVertxImplBase serviceImpl;
        private final int methodId;
        private final String compression;

        MethodHandlers(ReconnectServiceVertxImplBase serviceImpl, int methodId, String compression) {
            this.serviceImpl = serviceImpl;
            this.methodId = methodId;
            this.compression = compression;
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_START:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (com.google.protobuf.EmptyProtos.Empty) request,
                            (io.grpc.stub.StreamObserver<com.google.protobuf.EmptyProtos.Empty>) responseObserver,
                            compression,
                            serviceImpl::start);
                    break;
                case METHODID_STOP:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (com.google.protobuf.EmptyProtos.Empty) request,
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.ReconnectInfo>) responseObserver,
                            compression,
                            serviceImpl::stop);
                    break;
                default:
                    throw new java.lang.AssertionError();
            }
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public io.grpc.stub.StreamObserver<Req> invoke(io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                default:
                    throw new java.lang.AssertionError();
            }
        }
    }

}
