package io.grpc.testing.integration;

import static io.grpc.testing.integration.TestServiceGrpc.getServiceDescriptor;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;


@javax.annotation.Generated(
value = "by VertxGrpc generator",
comments = "Source: test.proto")
public final class VertxTestServiceGrpc {
    private VertxTestServiceGrpc() {}

    public static TestServiceVertxStub newVertxStub(io.grpc.Channel channel) {
        return new TestServiceVertxStub(channel);
    }

    /**
     * <pre>
     *  A simple service to test the various types of RPCs and experiment with
     *  performance with various types of payload.
     * </pre>
     */
    public static final class TestServiceVertxStub extends io.grpc.stub.AbstractStub<TestServiceVertxStub> {
        private final io.vertx.core.impl.ContextInternal ctx;
        private TestServiceGrpc.TestServiceStub delegateStub;

        private TestServiceVertxStub(io.grpc.Channel channel) {
            super(channel);
            delegateStub = TestServiceGrpc.newStub(channel);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        private TestServiceVertxStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            super(channel, callOptions);
            delegateStub = TestServiceGrpc.newStub(channel).build(channel, callOptions);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        @Override
        protected TestServiceVertxStub build(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            return new TestServiceVertxStub(channel, callOptions);
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> emptyCall(com.google.protobuf.EmptyProtos.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::emptyCall);
        }

        /**
         * <pre>
         *  One request followed by one response.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.SimpleResponse> unaryCall(io.grpc.testing.integration.Messages.SimpleRequest request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::unaryCall);
        }

        /**
         * <pre>
         *  The test server will not implement this method. It will be used
         *  to test the behavior when clients call unimplemented methods.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> unimplementedCall(com.google.protobuf.EmptyProtos.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::unimplementedCall);
        }

        /**
         * <pre>
         *  One request followed by a sequence of responses (streamed download).
         *  The server returns the payload with client desired type and sizes.
         * </pre>
         */
        public io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> streamingOutputCall(io.grpc.testing.integration.Messages.StreamingOutputCallRequest request) {
            return io.vertx.grpc.stub.ClientCalls.oneToMany(ctx, request, delegateStub::streamingOutputCall);
        }

        /**
         * <pre>
         *  A sequence of requests followed by one response (streamed upload).
         *  The server returns the aggregated size of client payload as the result.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.StreamingInputCallResponse> streamingInputCall(io.vertx.core.Handler<io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingInputCallRequest>> hdlr) {
            return io.vertx.grpc.stub.ClientCalls.manyToOne(ctx, hdlr, delegateStub::streamingInputCall);
        }

        /**
         * <pre>
         *  A sequence of requests with each request served by the server immediately.
         *  As one request could lead to multiple responses, this interface
         *  demonstrates the idea of full duplexing.
         * </pre>
         */
        public io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> fullDuplexCall(io.vertx.core.Handler<io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingOutputCallRequest>> hdlr) {
            return io.vertx.grpc.stub.ClientCalls.manyToMany(ctx, hdlr, delegateStub::fullDuplexCall);
        }
        /**
         * <pre>
         *  A sequence of requests followed by a sequence of responses.
         *  The server buffers all the client requests and then serves them in order. A
         *  stream of responses are returned to the client when the server starts with
         *  first request.
         * </pre>
         */
        public io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> halfDuplexCall(io.vertx.core.Handler<io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingOutputCallRequest>> hdlr) {
            return io.vertx.grpc.stub.ClientCalls.manyToMany(ctx, hdlr, delegateStub::halfDuplexCall);
        }
    }

    /**
     * <pre>
     *  A simple service to test the various types of RPCs and experiment with
     *  performance with various types of payload.
     * </pre>
     */
    public static abstract class TestServiceVertxImplBase implements io.grpc.BindableService {
        private String compression;

        /**
         * Set whether the server will try to use a compressed response.
         *
         * @param compression the compression, e.g {@code gzip}
         */
        public TestServiceVertxImplBase withCompression(String compression) {
            this.compression = compression;
            return this;
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> emptyCall(com.google.protobuf.EmptyProtos.Empty request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  One request followed by one response.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.SimpleResponse> unaryCall(io.grpc.testing.integration.Messages.SimpleRequest request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  The test server will not implement this method. It will be used
         *  to test the behavior when clients call unimplemented methods.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> unimplementedCall(com.google.protobuf.EmptyProtos.Empty request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  One request followed by a sequence of responses (streamed download).
         *  The server returns the payload with client desired type and sizes.
         * </pre>
         */
        public void streamingOutputCall(io.grpc.testing.integration.Messages.StreamingOutputCallRequest request, io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> response) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  A sequence of requests followed by one response (streamed upload).
         *  The server returns the aggregated size of client payload as the result.
         * </pre>
         */
        public io.vertx.core.Future<io.grpc.testing.integration.Messages.StreamingInputCallResponse> streamingInputCall(io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingInputCallRequest> request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  A sequence of requests with each request served by the server immediately.
         *  As one request could lead to multiple responses, this interface
         *  demonstrates the idea of full duplexing.
         * </pre>
         */
        public void fullDuplexCall(io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingOutputCallRequest> request, io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> response) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        /**
         * <pre>
         *  A sequence of requests followed by a sequence of responses.
         *  The server buffers all the client requests and then serves them in order. A
         *  stream of responses are returned to the client when the server starts with
         *  first request.
         * </pre>
         */
        public void halfDuplexCall(io.vertx.core.streams.ReadStream<io.grpc.testing.integration.Messages.StreamingOutputCallRequest> request, io.vertx.core.streams.WriteStream<io.grpc.testing.integration.Messages.StreamingOutputCallResponse> response) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
            return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getEmptyCallMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            com.google.protobuf.EmptyProtos.Empty,
                                            com.google.protobuf.EmptyProtos.Empty>(
                                            this, METHODID_EMPTY_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getUnaryCallMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            io.grpc.testing.integration.Messages.SimpleRequest,
                                            io.grpc.testing.integration.Messages.SimpleResponse>(
                                            this, METHODID_UNARY_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getStreamingOutputCallMethod(),
                            asyncServerStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.testing.integration.Messages.StreamingOutputCallRequest,
                                            io.grpc.testing.integration.Messages.StreamingOutputCallResponse>(
                                            this, METHODID_STREAMING_OUTPUT_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getStreamingInputCallMethod(),
                            asyncClientStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.testing.integration.Messages.StreamingInputCallRequest,
                                            io.grpc.testing.integration.Messages.StreamingInputCallResponse>(
                                            this, METHODID_STREAMING_INPUT_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getFullDuplexCallMethod(),
                            asyncBidiStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.testing.integration.Messages.StreamingOutputCallRequest,
                                            io.grpc.testing.integration.Messages.StreamingOutputCallResponse>(
                                            this, METHODID_FULL_DUPLEX_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getHalfDuplexCallMethod(),
                            asyncBidiStreamingCall(
                                    new MethodHandlers<
                                            io.grpc.testing.integration.Messages.StreamingOutputCallRequest,
                                            io.grpc.testing.integration.Messages.StreamingOutputCallResponse>(
                                            this, METHODID_HALF_DUPLEX_CALL, compression)))
                    .addMethod(
                            io.grpc.testing.integration.TestServiceGrpc.getUnimplementedCallMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            com.google.protobuf.EmptyProtos.Empty,
                                            com.google.protobuf.EmptyProtos.Empty>(
                                            this, METHODID_UNIMPLEMENTED_CALL, compression)))
                    .build();
        }
    }

    private static final int METHODID_EMPTY_CALL = 0;
    private static final int METHODID_UNARY_CALL = 1;
    private static final int METHODID_STREAMING_OUTPUT_CALL = 2;
    private static final int METHODID_STREAMING_INPUT_CALL = 3;
    private static final int METHODID_FULL_DUPLEX_CALL = 4;
    private static final int METHODID_HALF_DUPLEX_CALL = 5;
    private static final int METHODID_UNIMPLEMENTED_CALL = 6;

    private static final class MethodHandlers<Req, Resp> implements
            io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {

        private final TestServiceVertxImplBase serviceImpl;
        private final int methodId;
        private final String compression;

        MethodHandlers(TestServiceVertxImplBase serviceImpl, int methodId, String compression) {
            this.serviceImpl = serviceImpl;
            this.methodId = methodId;
            this.compression = compression;
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_EMPTY_CALL:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (com.google.protobuf.EmptyProtos.Empty) request,
                            (io.grpc.stub.StreamObserver<com.google.protobuf.EmptyProtos.Empty>) responseObserver,
                            compression,
                            serviceImpl::emptyCall);
                    break;
                case METHODID_UNARY_CALL:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (io.grpc.testing.integration.Messages.SimpleRequest) request,
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.SimpleResponse>) responseObserver,
                            compression,
                            serviceImpl::unaryCall);
                    break;
                case METHODID_STREAMING_OUTPUT_CALL:
                    io.vertx.grpc.stub.ServerCalls.oneToMany(
                            (io.grpc.testing.integration.Messages.StreamingOutputCallRequest) request,
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.StreamingOutputCallResponse>) responseObserver,
                            compression,
                            serviceImpl::streamingOutputCall);
                    break;
                case METHODID_UNIMPLEMENTED_CALL:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (com.google.protobuf.EmptyProtos.Empty) request,
                            (io.grpc.stub.StreamObserver<com.google.protobuf.EmptyProtos.Empty>) responseObserver,
                            compression,
                            serviceImpl::unimplementedCall);
                    break;
                default:
                    throw new java.lang.AssertionError();
            }
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public io.grpc.stub.StreamObserver<Req> invoke(io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_STREAMING_INPUT_CALL:
                    return (io.grpc.stub.StreamObserver<Req>) io.vertx.grpc.stub.ServerCalls.manyToOne(
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.StreamingInputCallResponse>) responseObserver,
                            compression,
                            serviceImpl::streamingInputCall);
                case METHODID_FULL_DUPLEX_CALL:
                    return (io.grpc.stub.StreamObserver<Req>) io.vertx.grpc.stub.ServerCalls.manyToMany(
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.StreamingOutputCallResponse>) responseObserver,
                            compression,
                            serviceImpl::fullDuplexCall);
                case METHODID_HALF_DUPLEX_CALL:
                    return (io.grpc.stub.StreamObserver<Req>) io.vertx.grpc.stub.ServerCalls.manyToMany(
                            (io.grpc.stub.StreamObserver<io.grpc.testing.integration.Messages.StreamingOutputCallResponse>) responseObserver,
                            compression,
                            serviceImpl::halfDuplexCall);
                default:
                    throw new java.lang.AssertionError();
            }
        }
    }

}
