package io.grpc.testing.integration;

import static io.grpc.testing.integration.UnimplementedServiceGrpc.getServiceDescriptor;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;


@javax.annotation.Generated(
value = "by VertxGrpc generator",
comments = "Source: test.proto")
public final class VertxUnimplementedServiceGrpc {
    private VertxUnimplementedServiceGrpc() {}

    public static UnimplementedServiceVertxStub newVertxStub(io.grpc.Channel channel) {
        return new UnimplementedServiceVertxStub(channel);
    }

    /**
     * <pre>
     *  A simple service NOT implemented at servers so clients can test for
     *  that case.
     * </pre>
     */
    public static final class UnimplementedServiceVertxStub extends io.grpc.stub.AbstractStub<UnimplementedServiceVertxStub> {
        private final io.vertx.core.impl.ContextInternal ctx;
        private UnimplementedServiceGrpc.UnimplementedServiceStub delegateStub;

        private UnimplementedServiceVertxStub(io.grpc.Channel channel) {
            super(channel);
            delegateStub = UnimplementedServiceGrpc.newStub(channel);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        private UnimplementedServiceVertxStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            super(channel, callOptions);
            delegateStub = UnimplementedServiceGrpc.newStub(channel).build(channel, callOptions);
            this.ctx = (io.vertx.core.impl.ContextInternal) io.vertx.core.Vertx.currentContext();
        }

        @Override
        protected UnimplementedServiceVertxStub build(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
            return new UnimplementedServiceVertxStub(channel, callOptions);
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> unimplementedCall(com.google.protobuf.EmptyProtos.Empty request) {
            return io.vertx.grpc.stub.ClientCalls.oneToOne(ctx, request, delegateStub::unimplementedCall);
        }

    }

    /**
     * <pre>
     *  A simple service NOT implemented at servers so clients can test for
     *  that case.
     * </pre>
     */
    public static abstract class UnimplementedServiceVertxImplBase implements io.grpc.BindableService {
        private String compression;

        /**
         * Set whether the server will try to use a compressed response.
         *
         * @param compression the compression, e.g {@code gzip}
         */
        public UnimplementedServiceVertxImplBase withCompression(String compression) {
            this.compression = compression;
            return this;
        }

        /**
         * <pre>
         *  One empty request followed by one empty response.
         * </pre>
         */
        public io.vertx.core.Future<com.google.protobuf.EmptyProtos.Empty> unimplementedCall(com.google.protobuf.EmptyProtos.Empty request) {
            throw new io.grpc.StatusRuntimeException(io.grpc.Status.UNIMPLEMENTED);
        }

        @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
            return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
                    .addMethod(
                            io.grpc.testing.integration.UnimplementedServiceGrpc.getUnimplementedCallMethod(),
                            asyncUnaryCall(
                                    new MethodHandlers<
                                            com.google.protobuf.EmptyProtos.Empty,
                                            com.google.protobuf.EmptyProtos.Empty>(
                                            this, METHODID_UNIMPLEMENTED_CALL, compression)))
                    .build();
        }
    }

    private static final int METHODID_UNIMPLEMENTED_CALL = 0;

    private static final class MethodHandlers<Req, Resp> implements
            io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
            io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {

        private final UnimplementedServiceVertxImplBase serviceImpl;
        private final int methodId;
        private final String compression;

        MethodHandlers(UnimplementedServiceVertxImplBase serviceImpl, int methodId, String compression) {
            this.serviceImpl = serviceImpl;
            this.methodId = methodId;
            this.compression = compression;
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                case METHODID_UNIMPLEMENTED_CALL:
                    io.vertx.grpc.stub.ServerCalls.oneToOne(
                            (com.google.protobuf.EmptyProtos.Empty) request,
                            (io.grpc.stub.StreamObserver<com.google.protobuf.EmptyProtos.Empty>) responseObserver,
                            compression,
                            serviceImpl::unimplementedCall);
                    break;
                default:
                    throw new java.lang.AssertionError();
            }
        }

        @java.lang.Override
        @java.lang.SuppressWarnings("unchecked")
        public io.grpc.stub.StreamObserver<Req> invoke(io.grpc.stub.StreamObserver<Resp> responseObserver) {
            switch (methodId) {
                default:
                    throw new java.lang.AssertionError();
            }
        }
    }

}
